
Name:           qcoro
Version:        0.7.0
Release:        %mkrel 2
Summary:        C++ Coroutines for Qt
Group:          System/Libraries
License:        MIT
URL:            https://github.com/danvratil/%{name}
Source0:        %{url}/archive/v%{version}/%{name}-%{version}.tar.gz
BuildRequires:  pkgconfig(xkbcommon)
BuildRequires:  cmake
BuildRequires:  dbus-x11
BuildRequires:  ninja

%description
The QCoro library provides set of tools to make use of the C++20 coroutines
in connection with certain asynchronous Qt actions.

The major benefit of using coroutines with Qt types is that it allows writing
asynchronous code as if it were synchronous and, most importantly, while the
coroutine is co_awaiting, the Qt event loop runs as usual, meaning that your
application remains responsive.

#--------------------------------------------------------------------

%define qcoroqt5_major 0
%define libqcoro5core %mklibname qcoro5core %{qcoroqt5_major}

%package -n %{libqcoro5core}
Summary:        C++ Coroutines for Qt 5
Group:          System/Libraries


%description -n %{libqcoro5core}
The QCoro library provides set of tools to make use of the C++20 coroutines
in connection with certain asynchronous Qt actions.

The major benefit of using coroutines with Qt types is that it allows writing
asynchronous code as if it were synchronous and, most importantly, while the
coroutine is co_awaiting, the Qt event loop runs as usual, meaning that your
application remains responsive.

#--------------------------------------------------------------------

%define qcoroqt5_major 0
%define libqcoro5dbus %mklibname qcoro5dbus %{qcoroqt5_major}

%package -n %{libqcoro5dbus}
Summary:        C++ Coroutines for Qt 5
Group:          System/Libraries

%description -n %{libqcoro5dbus}
The QCoro library provides set of tools to make use of the C++20 coroutines
in connection with certain asynchronous Qt actions.

The major benefit of using coroutines with Qt types is that it allows writing
asynchronous code as if it were synchronous and, most importantly, while the
coroutine is co_awaiting, the Qt event loop runs as usual, meaning that your
application remains responsive.

#--------------------------------------------------------------------

%define qcoroqt5_major 0
%define libqcoro5network %mklibname qcoro5network %{qcoroqt5_major}

%package -n %{libqcoro5network}
Summary:        C++ Coroutines for Qt 5
Group:          System/Libraries

%description -n %{libqcoro5network}
The QCoro library provides set of tools to make use of the C++20 coroutines
in connection with certain asynchronous Qt actions.

The major benefit of using coroutines with Qt types is that it allows writing
asynchronous code as if it were synchronous and, most importantly, while the
coroutine is co_awaiting, the Qt event loop runs as usual, meaning that your
application remains responsive.

#--------------------------------------------------------------------

%define qcoroqt5_major 0
%define libqcoro5qml %mklibname qcoro5qml %{qcoroqt5_major}

%package -n %{libqcoro5qml}
Summary:        C++ Coroutines for Qt 5
Group:          System/Libraries

%description -n %{libqcoro5qml}
The QCoro library provides set of tools to make use of the C++20 coroutines
in connection with certain asynchronous Qt actions.

The major benefit of using coroutines with Qt types is that it allows writing
asynchronous code as if it were synchronous and, most importantly, while the
coroutine is co_awaiting, the Qt event loop runs as usual, meaning that your
application remains responsive.

#--------------------------------------------------------------------

%define qcoroqt5_major 0
%define libqcoro5quick %mklibname qcoro5quick %{qcoroqt5_major}

%package -n %{libqcoro5quick}
Summary:        C++ Coroutines for Qt 5
Group:          System/Libraries

%description -n %{libqcoro5quick}
The QCoro library provides set of tools to make use of the C++20 coroutines
in connection with certain asynchronous Qt actions.

The major benefit of using coroutines with Qt types is that it allows writing
asynchronous code as if it were synchronous and, most importantly, while the
coroutine is co_awaiting, the Qt event loop runs as usual, meaning that your
application remains responsive.

#--------------------------------------------------------------------

%define qcoroqt5_major 0
%define libqcoro5websockets %mklibname qcoro5websockets %{qcoroqt5_major}

%package -n %{libqcoro5websockets}
Summary:        C++ Coroutines for Qt 5
Group:          System/Libraries

%description -n %{libqcoro5websockets}
The QCoro library provides set of tools to make use of the C++20 coroutines
in connection with certain asynchronous Qt actions.

The major benefit of using coroutines with Qt types is that it allows writing
asynchronous code as if it were synchronous and, most importantly, while the
coroutine is co_awaiting, the Qt event loop runs as usual, meaning that your
application remains responsive.

#--------------------------------------------------------------------

%define qcoroqt5_devel %mklibname qcoro-qt5 -d

%package -n %{qcoroqt5_devel}
Summary:        Development files for %{appname} (Qt 5 version)
Group:          Development/Libraries
Requires:       %{libqcoro5core} = %{version}-%{release}
Requires:       %{libqcoro5dbus} = %{version}-%{release}
Requires:       %{libqcoro5network} = %{version}-%{release}
Requires:       %{libqcoro5qml} = %{version}-%{release}
Requires:       %{libqcoro5quick} = %{version}-%{release}
Requires:       %{libqcoro5websockets} = %{version}-%{release}
Provides:       %{name}-devel = %{version}-%{release}
Provides:       %{name}-qt5-devel = %{version}-%{release}

%description -n %{qcoroqt5_devel}
This package contains header files needed if you wish to build applications
based on %{appname} (Qt 5 version).


#--------------------------------------------------------------------

%prep
%setup -q
sed -e '/-Werror/d' -i CMakeLists.txt

%build
%cmake \
    -DCMAKE_BUILD_TYPE=Release \
    -DUSE_QT_VERSION:STRING=5 \
    -DBUILD_TESTING:BOOL=ON \
    -DQCORO_BUILD_EXAMPLES:BOOL=ON \
    -DQCORO_ENABLE_ASAN:BOOL=OFF \
    -DQCORO_WITH_QML:BOOL=ON \
    -DQCORO_WITH_QTDBUS:BOOL=ON \
    -DQCORO_WITH_QTNETWORK:BOOL=ON \
    -DQCORO_WITH_QTQUICK:BOOL=ON \
    -DQCORO_WITH_QTWEBSOCKETS:BOOL=ON
%cmake_build


%install
%cmake_install


%files -n %{libqcoro5core}
%{_libdir}/libQCoro5Core.so.%{qcoroqt5_major}
%{_libdir}/libQCoro5Core.so.%{version}

%files -n %{libqcoro5dbus}
%{_libdir}/libQCoro5DBus.so.%{qcoroqt5_major}
%{_libdir}/libQCoro5DBus.so.%{version}

%files -n %{libqcoro5network}
%{_libdir}/libQCoro5Network.so.%{qcoroqt5_major}
%{_libdir}/libQCoro5Network.so.%{version}

%files -n %{libqcoro5qml}
%{_libdir}/libQCoro5Qml.so.%{qcoroqt5_major}
%{_libdir}/libQCoro5Qml.so.%{version}

%files -n %{libqcoro5quick}
%{_libdir}/libQCoro5Quick.so.%{qcoroqt5_major}
%{_libdir}/libQCoro5Quick.so.%{version}

%files -n %{libqcoro5websockets}
%{_libdir}/libQCoro5WebSockets.so.%{qcoroqt5_major}
%{_libdir}/libQCoro5WebSockets.so.%{version}

%files -n %{qcoroqt5_devel}
%{_includedir}/%{name}5/
%{_libdir}/cmake/*5*/
%{_libdir}/libQCoro5Core.so
%{_libdir}/libQCoro5DBus.so
%{_libdir}/libQCoro5Network.so
%{_libdir}/libQCoro5Qml.so
%{_libdir}/libQCoro5Quick.so
%{_libdir}/libQCoro5WebSockets.so
%{_libdir}/qt5/mkspecs/modules/qt_*.pri

%changelog
* Wed Jun 28 2023 tex - 0.7.0-2pclos2023
- rebuild against updates

* Fri Apr 21 2023 tex- 0.7.0-1pclos2023
- create pkg
